Tutorials:

- Classic Mean Risk Optimization [Tutorial 1](https://github.com/dcajasn/Riskfolio-Lib/blob/master/examples/Tutorial%201%20-%20Classic%20Mean%20Risk%20Optimization.ipynb)
- Risk Factors using Stepwise Regression [Tutorial 2](https://github.com/dcajasn/Riskfolio-Lib/blob/master/examples/Tutorial%202%20-%20Portfolio%20Optimization%20with%20Risk%20Factors%20using%20Stepwise%20Regression.ipynb)
- Black Litterman Mean Risk Optimization [Tutorial 3](https://github.com/dcajasn/Riskfolio-Lib/blob/master/examples/Tutorial%203%20-%20Black%20Litterman%20Mean%20Risk%20Optimization.ipynb) 
- Bond Optimization and Immunization [Tutorial 4](https://github.com/dcajasn/Riskfolio-Lib/blob/master/examples/Tutorial%204%20-%20Bond%20Portfolio%20Optimization%20and%20Immunization.ipynb)
- Multi Assets Algorithmic Trading Backtesting with Backtrader [Tutorial 5](https://github.com/dcajasn/Riskfolio-Lib/blob/master/examples/Tutorial%205%20-%20Multi%20Assets%20Algorithmic%20Trading%20Backtesting%20with%20Backtrader.ipynb)
- Portfolio Optimization with Custom Parameters [Tutorial 6](https://github.com/dcajasn/Riskfolio-Lib/blob/master/examples/Tutorial%206%20-%20Portfolio%20Optimization%20with%20Custom%20Parameters.ipynb)
- Index Tracking / Replicating Portfolios [Tutorial 7](https://github.com/dcajasn/Riskfolio-Lib/blob/master/examples/Tutorial%207%20-%20Index%20Tracking-Replicating%20Portfolios.ipynb)
- Short and Leveraged Portfolios [Tutorial 8](https://github.com/dcajasn/Riskfolio-Lib/blob/master/examples/Tutorial%208%20-%20Short%20and%20Leveraged%20Portfolios.ipynb)
- Portfolio Optimization with Risk Factors and Principal Components Regression (PCR) [Tutorial 9](https://github.com/dcajasn/Riskfolio-Lib/blob/master/examples/Tutorial%209%20-%20Portfolio%20Optimization%20with%20Risk%20Factors%20and%20Principal%20Components%20Regression%20(PCR).ipynb)
- Risk Parity Portfolio Optimization [Tutorial 10](https://github.com/dcajasn/Riskfolio-Lib/blob/master/examples/Tutorial%2010%20-%20Risk%20Parity%20Portfolio%20Optimization.ipynb)
- Risk Parity Portfolio Optimization with Risk Factors using Stepwise Regression [Tutorial 11](https://github.com/dcajasn/Riskfolio-Lib/blob/master/examples/Tutorial%2011%20-%20Risk%20Parity%20Portfolio%20Optimization%20with%20Risk%20Factors%20using%20Stepwise%20Regression.ipynb)
- Worst Case Mean Variance Portfolio Optimization [Tutorial 12](https://github.com/dcajasn/Riskfolio-Lib/blob/master/examples/Tutorial%2012%20-%20Worst%20Case%20Mean%20Variance%20Portfolio%20Optimization.ipynb)
- Riskfolio-Lib and Xlwings [Tutorial 13](https://github.com/dcajasn/Riskfolio-Lib/blob/master/examples/Tutorial%2013%20-%20Riskfolio-Lib%20and%20Xlwings.ipynb)
- Mean Ulcer Index Portfolio Optimization [Tutorial 14](https://github.com/dcajasn/Riskfolio-Lib/blob/master/examples/Tutorial%2014%20-%20Mean%20Ulcer%20Index%20Portfolio%20Optimization.ipynb)
- Mean Entropic Value at Risk (EVaR) Optimization [Tutorial 15](https://github.com/dcajasn/Riskfolio-Lib/blob/master/examples/Tutorial%2015%20-%20Mean%20Entropic%20Value%20at%20Risk%20(EVaR)%20Optimization.ipynb)
- Riskfolio-Lib Reports in Jupyter Notebook and Excel [Tutorial 16](https://github.com/dcajasn/Riskfolio-Lib/blob/master/examples/Tutorial%2016%20-%20Riskfolio-Lib%20Reports%20in%20Jupyter%20Notebook%20and%20Excel.ipynb)
- Riskfolio-Lib with MOSEK for Real Applications [Tutorial 17](https://github.com/dcajasn/Riskfolio-Lib/blob/master/examples/Tutorial%2017%20-%20Riskfolio-Lib%20with%20MOSEK%20for%20Real%20Applications%20(612%20assets%20and%204943%20observations).ipynb)
- Multi Assets Algorithmic Trading Backtesting with Vectorbt [Tutorial 18](https://github.com/dcajasn/Riskfolio-Lib/blob/master/examples/Tutorial%2018%20-%20Multi%20Assets%20Algorithmic%20Trading%20Backtesting%20with%20Vectorbt.ipynb)
- Mean Entropic Drawdown at Risk (EDaR) Optimization [Tutorial 17](https://github.com/dcajasn/Riskfolio-Lib/blob/master/examples/Tutorial%2019.ipynb)
- Black Litterman with Factors Models Mean Risk Optimization [Tutorial 18](https://github.com/dcajasn/Riskfolio-Lib/blob/master/examples/Tutorial%2020.ipynb)
- Constraints on Return and Risk Measures [Tutorial 19](https://github.com/dcajasn/Riskfolio-Lib/blob/master/examples/Tutorial%2019%20-%20Mean%20Entropic%20Drawdown%20at%20Risk%20(EDaR)%20Optimization.ipynb)
- Mean Entropic Drawdown at Risk (EDaR) Optimization [Tutorial 20](https://github.com/dcajasn/Riskfolio-Lib/blob/master/examples/Tutorial%2020%20-%20Black%20Litterman%20with%20Factors%20Models%20Mean%20Risk%20Optimization.ipynb)
- Constraints on Return and Risk Measures [Tutorial 21](https://github.com/dcajasn/Riskfolio-Lib/blob/master/examples/Tutorial%2021%20-%20Constraints%20on%20Return%20and%20Risk%20Measures.ipynb)
- Logarithmic Mean Risk Optimization (Kelly Criterion) [Tutorial 22](https://github.com/dcajasn/Riskfolio-Lib/blob/master/examples/Tutorial%2022%20-%20Logarithmic%20Mean%20Risk%20Optimization%20(Kelly%20Criterion).ipynb)
- Dollar Neutral Portfolios [Tutorial 23](https://github.com/dcajasn/Riskfolio-Lib/blob/master/examples/Tutorial%2023%20-%20Dollar%20Neutral%20Portfolios.ipynb)
- Hierarchical Risk Parity (HRP) Portfolio Optimization [Tutorial 24](https://github.com/dcajasn/Riskfolio-Lib/blob/master/examples/Tutorial%2024%20-%20Hierarchical%20Risk%20Parity%20(HRP)%20Portfolio%20Optimization.ipynb)
- Hierarchical Equal Risk Contribution (HERC) Portfolio Optimization [Tutorial 25](https://github.com/dcajasn/Riskfolio-Lib/blob/master/examples/Tutorial%2025%20-%20Hierarchical%20Equal%20Risk%20Contribution%20(HERC)%20Portfolio%20Optimization.ipynb)
- Constraints on Numbers of Assets [Tutorial 26](https://github.com/dcajasn/Riskfolio-Lib/blob/master/examples/Tutorial%2026%20-%20Constraints%20on%20Numbers%20of%20Assets.ipynb)
- HERC with Equal Weights within Clusters (HERC2) [Tutorial 27](https://github.com/dcajasn/Riskfolio-Lib/blob/master/examples/Tutorial%2027%20-%20HERC%20with%20Equal%20Weights%20within%20Clusters%20(HERC2).ipynb)
- Hierarchical Clustering and Networks [Tutorial 28](https://github.com/dcajasn/Riskfolio-Lib/blob/master/examples/Tutorial%2028%20-%20Hierarchical%20Clustering%20and%20Networks.ipynb)
- Hierarchical Risk Parity (HRP) Portfolio Optimization with Constraints [Tutorial 29](https://github.com/dcajasn/Riskfolio-Lib/blob/master/examples/Tutorial%2029%20-%20Hierarchical%20Risk%20Parity%20(HRP)%20Portfolio%20Optimization%20with%20Constraints.ipynb)
- Nested Clustered Optimization (NCO) [Tutorial 30](https://github.com/dcajasn/Riskfolio-Lib/blob/master/examples/Tutorial%2030%20-%20Nested%20Clustered%20Optimization%20(NCO).ipynb)
- Hierarchical Portfolios with Custom Covariance [Tutorial 31](https://github.com/dcajasn/Riskfolio-Lib/blob/master/examples/Tutorial%2031%20-%20Hierarchical%20Portfolios%20with%20Custom%20Covariance.ipynb)
- Relaxed Risk Parity Portfolio Optimization [Tutorial 32](https://github.com/dcajasn/Riskfolio-Lib/blob/master/examples/Tutorial%2032%20-%20Relaxed%20Risk%20Parity%20Portfolio%20Optimization.ipynb)
- Risk Parity with Constraints using the Risk Budgeting Approach [Tutorial 33](https://github.com/dcajasn/Riskfolio-Lib/blob/master/examples/Tutorial%2033%20-%20Risk%20Parity%20with%20Constraints%20using%20the%20Risk%20Budgeting%20Approach.ipynb)
- Comparing Covariance Estimators Methods [Tutorial 34](https://github.com/dcajasn/Riskfolio-Lib/blob/master/examples/Tutorial%2034%20-%20Comparing%20Covariance%20Estimators%20Methods.ipynb)
- Gini Mean Difference (GMD) Optimization [Tutorial 35](https://github.com/dcajasn/Riskfolio-Lib/blob/master/examples/Tutorial%2035%20-%20Gini%20Mean%20Difference%20(GMD)%20Optimization.ipynb)
- Mean Tail Gini Range Optimization [Tutorial 36](https://github.com/dcajasn/Riskfolio-Lib/blob/master/examples/Tutorial%2036%20-%20Mean%20Tail%20Gini%20Range%20Optimization.ipynb)
- OWA Portfolio Optimization [Tutorial 37](https://github.com/dcajasn/Riskfolio-Lib/blob/master/examples/Tutorial%2037%20-%20OWA%20Portfolio%20Optimization.ipynb)
- Kurtosis Portfolio Optimization for Mean Risk and Risk Parity [Tutorial 38](https://github.com/dcajasn/Riskfolio-Lib/blob/master/examples/Tutorial%2038%20-%20Mean%20Kurtosis%20Optimization.ipynb)
- Semi Kurtosis Portfolio Optimization for Mean Risk and Risk Parity [Tutorial 39](https://github.com/dcajasn/Riskfolio-Lib/blob/master/examples/Tutorial%2039%20-%20Mean%20Semi%20Kurtosis%20Optimization.ipynb)
- Relativistic Value at Risk (RLVaR) Portfolio Optimization for Mean Risk and Risk Parity [Tutorial 40](https://github.com/dcajasn/Riskfolio-Lib/blob/master/examples/Tutorial%2040%20-%20Mean%20Relativistic%20Value%20at%20Risk%20(RLVaR)%20Optimization.ipynb)
- Relativistic Drawdown at Risk (RLDaR) Portfolio Optimization for Mean Risk and Risk Parity [Tutorial 41](https://github.com/dcajasn/Riskfolio-Lib/blob/master/examples/Tutorial%2041%20-%20Mean%20Relativistic%20Drawdown%20at%20Risk%20(RLDaR)%20Optimization.ipynb)
- Higher L-Moments OWA Portfolio Optimization for Mean Risk and Risk Parity [Tutorial 42](https://nbviewer.jupyter.org/github/dcajasn/Riskfolio-Lib/blob/master/examples/Tutorial%2042%20-%20Higher%20L-Moments%20OWA%20Portfolio%20Optimization.ipynb)
- Risk Parity with a Risk Constraint per Classes [Tutorial 43](https://nbviewer.jupyter.org/github/dcajasn/Riskfolio-Lib/blob/master/examples/Tutorial%2043%20-%20Risk%20Parity%20with%20a%20Risk%20Constraint%20per%20Classes.ipynb)
- Hierarchical Equal Risk Contribution (HERC) Portfolio Optimization with Constraints [Tutorial 44](https://nbviewer.jupyter.org/github/dcajasn/Riskfolio-Lib/blob/master/examples/Tutorial 44 - Hierarchical Equal Risk Contribution (HERC) Portfolio Optimization with Constraints.ipynb)
- Nested Clustered Optimization (NCO) Portfolio Optimization with Constraints [Tutorial 45](https://nbviewer.jupyter.org/github/dcajasn/Riskfolio-Lib/blob/master/examples/Tutorial%2045%20-%20Nested%20Clustered%20Optimization%20(NCO)%20Portfolio%20Optimization%20with%20Constraints.ipynb)
- Classic Mean Risk Optimization with Network and Dendrogram Constraints [Tutorial 46](https://nbviewer.jupyter.org/github/dcajasn/Riskfolio-Lib/blob/master/examples/Tutorial%2046%20-%20Classic%20Mean%20Risk%20Optimization%20with%20Network%20and%20Dendrogram%20Constraints.ipynb)
- Risk Parity with Risk Factors [Tutorial 47](https://nbviewer.jupyter.org/github/dcajasn/Riskfolio-Lib/blob/master/examples/Tutorial%2047%20-%20Risk%20Parity%20with%20Risk%20Factors.ipynb)